function new_batch_predict(code,node_number,delays_number)
%-------------------------------------------------------------------------------------------------------------
%This program predicts amplitudes for a subject---------------------------------------------------------------
clc;
%how many instances of the signal to be used---
global st fin;
if (isempty(st)==1)
    clear global st fin;
    st = 171;
    fin = 251;
end
Type = 'High';
hid1 = 30;
hid2 = 20;
hid3 = 10;
trfun_dir = 'LM';
%-------------build last directory string------
strhid1 = int2str(hid1);
strhid2 = int2str(hid2);
ststr = int2str(st);
finstr = int2str(fin);
if hid3==0
    lastdir = [strhid1 '-' strhid2 '(' ststr '-' finstr ')'];
else
    strhid3 = int2str(hid3);
    lastdir = [strhid1 '-' strhid2 '-' strhid3 '(' ststr '-' finstr ')'];
end
%----------------------------------------------
%more strings
str = int2str(delays_number);
str2 = int2str(node_number);
%------------

%----------------------------------------------
%manipulate strings and opening the appropriate *.mat file-------
S1 = ['C:\Matlab\work\DATA\' Type '\'];  %['C:\Matlab\work\' Type '\' code]
cd (S1);
S2 = [code '_data'];
load(S2);
%----------------------------------------------------------------
global siz strinfo ncat categ;
if (isempty(siz)==1)
    clear global siz strinfo ncat categ;
    categ = {'Controls', 'OCD'};
    
    %load from data matrix the number of used subjects for current category
    S2 = ['C:\Matlab\work\NN-predict_next\' Type '\' trfun_dir '\net_delay' str '_electr' str2];
    cd(S2);
    temp = [S2 '\' code '_batch_matrix(' ststr '-' finstr ')'];
    load (temp,'used_subj');
    num = length(used_subj);
    numstr = int2str(num);
    %----------------------------------------------------------------------
    
    %name of the information text file that will be accessed
    strinfo = categ{1};
    for i=2:length(categ)
        strinfo = strcat(strinfo,'_',categ{i});
    end
    strinfo = strcat(strinfo,'-info.txt');
    %-------------------------------------------------------
    siz = 0;
    while (siz > num | siz < 1)
        clc;
        tmtx = ['There are ' numstr ' different trained networks'];
        disp(tmtx);
        tmtx = ['Press 1-' numstr ' to select a subject and predict'];
        disp(tmtx);
        siz = input('the performance with the only net that is not trained for the data:   ');
    end
else
    i = 1;
    while strcmp(code,categ{i})~=1
        i = i + 1;
    end
    used_subj = ncat{i};
end
clear siztmp tmtx numstr;

%use real subject number for results
sizstr = int2str(used_subj(siz));
if used_subj(siz)<10
    sizstr = ['0' sizstr];
end
%---------------------
f = fin-st+1;
%put this iteraction's data into array TEMP
TEMP(1:f) = AMP(node_number-1,st:fin,used_subj(siz));
clear AMP;
%build plot label-------
tmmp = used_subj(siz);
tmp = int2str(tmmp);
S3 = [code ' ' tmp];
clear tmp siz tmmp;
%----------------------------------------------------------------
%setting time----------------------------------
time = ((delays_number+st)*2):2:(2*(fin-1));
%----------------------------------------------


for j=1:length(categ)
%name of directory from which the trained net is to be loaded--------
sav = ['net_delay' str '_electr' str2];
%--------------------------------------------------------------------
%subdirectory name------------------------------------------
S2 = ['C:\Matlab\work\NN-predict_next\' Type '\' trfun_dir '\' sav '\' lastdir];
%-----------------------------------------------------------

%load the appropriate network or return error-------------------------------------------
try
    cd(S2);
    xstr = sizstr;
    if strcmp(code,categ{j}) == 1
        temp = [S2 '\' categ{j} '_batch_net(' ststr '-' finstr ')ex' sizstr '.mat'];
        load (temp);
    else
        try
            temp = [S2 '\' categ{j} '_batch_net(' ststr '-' finstr ')ex' sizstr '.mat'];
            load (temp);
        catch
            temp = [S2 '\' categ{j} '_batch_net(' ststr '-' finstr ')ex01.mat']; %ALTER
            load (temp);
            xstr = '01';
        end
    end
    load (temp);
    clear temp;
    TEMP2 = tramnmx(TEMP,minM,maxM);
catch
    disp('Error in loading trained batch network for predicting');
    error('Enter the appropriate time parameters or train a net with function batch_train');
end

%--------------------------------------------------------------------------------------
%plotting phase 1--------------------------------------------------------------
plot(time,TEMP((delays_number+2):f),'-g');
hold on;
legend(S3,4);
axis([0 1020 -30 30]);
xlabel('Time');
ylabel('Amplitude');
stitle=['Electrode ' str2 ' | delays: ' str];
title(stitle);
%----------------------------------------------
disp('------------------------------------------------------------------------------------------------------');
disp('Press a key to continue');
%----------------------------------------------
plot([0 1020],[0 0],'k');
legend(S3,'zero',4);
t = TEMP((delays_number+2):f);  %temp matrix t for error plotting
%end plotting phase 1----------------------------------------------------------

%build inputs and initial delays-------------------------------------
P = TEMP2(delays_number+1);
Pf = TEMP2(1:delays_number);
clear TEMP2;
%--------------------------------------------------------------------

%NET adapt and plotting----------------------------------------------------------
%initializing output, error and time
YN=P; EP1=0; TimeN=time(1); SUM=0; tmcnt=0;
%-----------------------------------
for i=1:(fin-st-delays_number) 
    TimeO=TimeN;
    TimeN=time(i);
    YO=YN;
    [Y,Pf] = sim(net,YN,Pf);
    YN=Y(1);
    %postprocessing for accurate plotting
    YP1 = postmnmx(YN,minM,maxM);
    YP0 = postmnmx(YO,minM,maxM);
    %------------------------------------
    %indirect calculation of the error for displaying
    EP0 = EP1;
    EP1 = YP1 - t(i);
    %if i < 36
        SUM = SUM + EP1*EP1;
        tmcnt = tmcnt + 1;
    %end
    %---------------------
    %plot error and output
    plot([TimeO TimeN],[YP1 YP0],'b',[TimeO TimeN],[EP0 EP1],'r');
    %---------------------
    %legend-----------------------------------
    if i==1
       legend(S3,'zero','Output','Error',4);
    end
    %-----------------------------------------
    drawnow;
end
%calculating and displaying MSE---------
MErr = SUM/tmcnt;
strMSE = num2str(MErr,5);
dstr = ['MSE=' strMSE];
text(28,28,dstr);
dstr = [categ{j} ' ex' xstr ' perf:'];
text(28,26,dstr);
strperf = num2str(perf);
text(28,24,strperf);
hold off;
%build info.txt-------------------------
ErrStr{j}=strMSE;
%---------------------------------------
sav = ['net' '_delay' str '_electr' str2];
S2 = ['C:\Matlab\work\NN-predict_next\' Type '\' trfun_dir '\' sav '\' lastdir];
cd (S2);
tmstr = [S3 '-' categ{j}];
print('-f1','-dbmp','-r100', tmstr);
clear minM maxM;
delete(gcf);
end

%build info.txt-------------------------
tmp_info_str = [code ' ' sizstr ':   ' categ{1} '=' ErrStr{1} ' ' categ{2} '=' ErrStr{2} '\n']; % ' ' categ{3} '=' ErrStr{3}
txt = fopen(strinfo,'at');
fprintf(txt, tmp_info_str);
fclose(txt);
%---------------------------------------